#ifndef GC_HPTHREADING_HH_
#define GC_HPTHREADING_HH_


#include "cpsp/HPThreadingHandler.hh"
#include "cpsp/HPThreadingOptions.hh"

namespace cpsp
{
	
  /**
   * The "gecode" namespace collects all classes neccessary for an 
   * implementation of CPSP with the Gecode(TM) constraint programming
   * library.
   * 
   * http://www.gecode.org
   */
  namespace gecode
  {
  	
		/**
		 * This is a HPThreadingHandler implementation using the constraint
		 * propagation library Gecode(TM)
		 */
	class GC_HPThreading : public cpsp::HPThreadingHandler
	{
		
	private:
		
			//! the options for threading generated from program parameters etc.
		cpsp::HPThreadingOptions *	opts;
		
	public:
			//! construction
		GC_HPThreading(cpsp::HPThreadingOptions * const opts_);
		virtual ~GC_HPThreading();
		
			// abstract function implementation
		virtual void generateStructures();
		
	};

  } // namespace gecode
} // namespace cpsp

#endif /*GC_HPTHREADING_HH_*/
