
#include <iostream>
#include "cpsp/HPThreadingOptions.hh"
#include "cpsp/gecode/GC_HPThreading.hh"



	int main(int argc, char**argv) {
		using namespace cpsp;
		using namespace cpsp::gecode;

		std::cout	<<"\n=================================="
					<<"\n   HPstruct - CPSP-tool-library"
					<<"\n=================================="
					<<"\n\n";
		try {
			
			// check user parameters
			HPThreadingOptions opts(argc,argv);
			
			// generate threading object with user parameter settings
			GC_HPThreading threading(&opts);
			
			// generate structures 
			threading.generateStructures();
			
		// catch errors in user parameters etc.
		} catch (cpsp::Exception& ex) {
			std::cerr <<"\n\t"+ex.toString()+"\n\n" <<std::endl;
			return ex.retValue;
		}

		std::cout	<<"\n==================================\n"
					<<std::endl;
		
		return 0;
	}

